﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using Infragistics.Controls.Charts;
using System.Diagnostics;

namespace XamDataChartPolarMousePointsCase
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        public MainWindow()
        {
            InitializeComponent();
        }

        private void XamDataChart_MouseMove(object sender, MouseEventArgs e)
        {
            Point p = e.GetPosition(chart.Series[0]);

            GetUnscaledValues(p.X, p.Y, p);
        }


        public void GetUnscaledValues(double pointX, double pointY, Point mousePosition)
        {

            Point center = new Point(.5, .5);

            Rect viewport = new Rect(0, 0, chart.Series[0].ActualWidth, chart.Series[0].ActualHeight);                       

            double X = TransformXFromViewport(pointX, chart.WindowRect, viewport);
            double Y = TransformYFromViewport(pointY, chart.WindowRect, viewport);

            double scaledRadius = Math.Sqrt(Math.Pow(X - center.X, 2) + Math.Pow(Y - center.Y, 2));
            double scaledAngle = Math.Acos((X - center.X) / scaledRadius);
            if ((Y - center.Y) < 0)
            {
                scaledAngle = (2.0 * Math.PI) - scaledAngle;
            }

            var x = AngleAxis.GetUnscaledAngle(scaledAngle);
            var y = RadiusAxis.GetUnscaledValue(scaledRadius);           

            AngleBox.Text = x.ToString();
            RadialBox.Text = y.ToString();
        }


        public double TransformXFromViewport(double xValue, Rect windowRect, Rect viewportRect)
        {
            return ((xValue - viewportRect.Left)
                * windowRect.Width / viewportRect.Width) + windowRect.Left;
        }


        public double TransformYFromViewport(double yValue, Rect windowRect, Rect viewportRect)
        {
            return ((yValue - viewportRect.Top)
                * windowRect.Height / viewportRect.Height) + windowRect.Top;
        }
    }
}
